<template>
    <div class="q-py-lg">
        <div class="row col-12" v-if="state.currentPage == 'label-update'">
            <update-label
                class="col-12"
                :label="state.selectedLabel"
                @update-confirm="updateConfirm"
            />
        </div>
        <div class="label-list" v-else>
            <!--             <div class="row">
                <div class="col-12 q-ml-md-md font-18 text-black q-mt-xs">
                    <q-btn flat no-caps @click="selectCurrentPage('default')">
                        <q-icon name="arrow_back" color="black" size="25px" />
                        <span class="font-18 helvetica-neue-medium q-pl-md">
                            {{ $t('button.back') }}
                        </span>
                    </q-btn>
                </div>
            </div> -->
            <!-- <div class="row justify-center item-center">
                <div class="col-12 q-pl-md-xl font-18 text-black q-mt-sm">
                    {{ $t('preference.customLabel') }}
                </div>
            </div> -->
            <div class="row justify-center item-center">
                <div class="col-12 q-pl-md-xl font-18 text-black q-mt-md">
                    <div class="row">
                        <div class="col-xs-12 col-md-4 col-lg-4 col-6">
                            <q-input
                                outlined
                                bottom-slots
                                v-model="search"
                                :label="$t('preference.searchLabel')"
                                :loading="state.loadingState"
                                debounce="500"
                                bg-color="transparent"
                                clearable
                                dense
                                class="text-5B9ADD"
                            >
                                <template v-slot:prepend>
                                    <q-icon name="search" class="text-5B9ADD" />
                                </template>
                            </q-input>
                        </div>
                        <div
                            class="
                                col-xs-12 col-md-7 col-lg-2 col-5
                                q-ml-md-md q-ml-xs-none
                            "
                        >
                            <q-btn
                                class="
                                    border-radius-10
                                    item-center
                                    q-px-lg
                                    font-16
                                    button-createLabel
                                "
                                text-color="white"
                                no-caps
                                :label="$t('button.createLabel')"
                                @click="selectCurrentPage('label-create')"
                                v-if="permissions.label?.create"
                            />
                        </div>
                    </div>
                    <div class="row justify-start q-mt-md">
                        <div
                            class="
                                label-container
                                col-sm-3 col-md-2 col-lg-1
                                q-pr-sm q-mb-lg q-pb-lg q-mr-md-sm q-mb-md-lg
                            "
                            v-for="(label, index) in state.labels"
                            :key="'label-' + index"
                        >
                            <q-card
                                flat
                                bordered
                                class="my-card border-radius-15"
                                :style="{
                                    backgroundColor: label.color
                                }"
                            >
                                <q-card-section class="q-pa-xs">
                                    <div class="row justify-end items-center">
                                        <div class="label-options">
                                            <q-btn
                                                size="md"
                                                class="card-btn"
                                                color="white"
                                                round
                                                flat
                                                icon="more_horiz"
                                            >
                                                <q-menu
                                                    class="label-menu"
                                                    fit
                                                    anchor="bottom right"
                                                    self="top start"
                                                    auto-close
                                                >
                                                    <q-list
                                                        class="
                                                            label-buttons-container
                                                        "
                                                    >
                                                        <q-item
                                                            class="
                                                                button-padding
                                                                q-pa-none
                                                            "
                                                            clickable
                                                            @click="
                                                                editLabel(label)
                                                            "
                                                            v-if="
                                                                permissions
                                                                    .label
                                                                    ?.update
                                                            "
                                                        >
                                                            <q-item-section
                                                                avatar
                                                            >
                                                                <q-icon
                                                                    color="primary"
                                                                    name="edit"
                                                                />
                                                            </q-item-section>
                                                            <q-item-section
                                                                class="
                                                                    label-buttons
                                                                    text-4586E1
                                                                "
                                                            >
                                                                {{
                                                                    $t(
                                                                        'button.edit'
                                                                    )
                                                                }}
                                                            </q-item-section>
                                                        </q-item>
                                                        <q-item
                                                            class="
                                                                button-padding
                                                                q-pa-none
                                                            "
                                                            clickable
                                                            @click="
                                                                removeLabel(
                                                                    label.id
                                                                )
                                                            "
                                                            v-if="
                                                                permissions
                                                                    .label
                                                                    ?.delete
                                                            "
                                                        >
                                                            <q-item-section
                                                                avatar
                                                            >
                                                                <q-icon
                                                                    class="
                                                                        remove-btn
                                                                    "
                                                                    name="delete"
                                                                />
                                                            </q-item-section>
                                                            <q-item-section
                                                                class="
                                                                    label-buttons
                                                                    text-FA6767
                                                                "
                                                            >
                                                                {{
                                                                    $t(
                                                                        'button.remove'
                                                                    )
                                                                }}
                                                            </q-item-section>
                                                        </q-item>
                                                    </q-list>
                                                </q-menu>
                                            </q-btn>
                                        </div>
                                    </div>
                                    <div
                                        class="
                                            row
                                            justify-center
                                            items-center
                                            q-mt-md
                                        "
                                    >
                                        <q-icon
                                            :name="label.icon"
                                            color="white"
                                            size="md"
                                        ></q-icon>
                                    </div>
                                    <div class="row justify-center q-mt-sm">
                                        <p
                                            class="
                                                font-18
                                                helvetica-neue-medium
                                                label-margin
                                            "
                                        >
                                            {{ label.name }}
                                        </p>
                                    </div>
                                </q-card-section>
                            </q-card>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    computed,
    watch,
    reactive,
    onMounted
} from 'vue';
import UpdateLabel from '../labels/UpdateLabel.vue';
import { mapGetters } from 'vuex';

export default defineComponent({
    name: 'RolesList',
    components: {
        UpdateLabel
    },
    computed: {
        ...mapGetters({
            permissions: 'role/getPermissions'
        })
    },
    setup(props, { emit }) {
        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });
        const search = ref('');
        let state = reactive({
            currentPage: 'label-home',
            roles: computed(() => {
                return store.state.role.role;
            }),
            loadingState: ref(false),
            colors: [
                {
                    id: 1,
                    name: '#4586E1'
                },
                {
                    id: 2,
                    name: '#8A6FF0'
                },
                {
                    id: 3,
                    name: '#FF6700'
                },
                {
                    id: 4,
                    name: '#46C883'
                },
                {
                    id: 5,
                    name: '#FFBB46'
                },
                {
                    id: 6,
                    name: '#FA6EAD'
                },
                {
                    id: 7,
                    name: '#29C5CE'
                },
                {
                    id: 8,
                    name: '#F09253'
                },
                {
                    id: 9,
                    name: '#F4656B'
                },
                {
                    id: 10,
                    name: '#7393C2'
                },
                {
                    id: 11,
                    name: '#C784AF'
                },
                {
                    id: 12,
                    name: '#00949D'
                }
            ],
            icons: [
                {
                    id: 1,
                    name: 'nightlight'
                },
                {
                    id: 2,
                    name: 'people'
                },
                {
                    id: 3,
                    name: 'campaign'
                }
            ],
            selectedLabel: {
                roleId: '',
                name: '',
                icon: '',
                color: ''
            },
            labels: [] as any,
            labelName: ref(''),
            selectedIcon: '',
            selectedColor: { name: '#666B72' },
            selectedPermission: [] as any,
            permissions: computed(() => {
                return store.state.role.permissions;
            })
        });

        const store = useStore();
        watch(selectedBusinessId, () => {
            if (selectedBusinessId.value) {
                getLabelList();
            }
        });

        const selectCurrentPage = (page: string) => {
            emit('change-page', page);
        };

        const updateConfirm = (value: any) => {
            state.currentPage = value;
        };

        watch(search, (currentValue) => {
            getLabels(currentValue);
        });

        const editLabel = (label: any) => {
            state.selectedLabel.roleId = label.id;
            state.selectedLabel = label;
            state.labelName = label.name;
            state.selectedColor.name = label.color;
            state.selectedIcon = label.icon;
            state.currentPage = 'label-update';
        };

        const getLabelList = async () => {
            // get label if authorized members
            if (store.state.role.permissions.label?.list) {
                await store.dispatch('label/getList', null, { root: true });
                getLabels();
            }
        };

        const removeLabel = async (id: any) => {
            if (state.permissions?.label?.delete == true) {
                await store.dispatch('label/delete', {
                    labelId: id
                });
            }
        };

        const updateLabelList = (result: any) => {
            state.labels = result;
        };

        const getLabels = (text?: string) => {
            state.labels = [];
            store.state.label.list.forEach((element: any) => {
                if (text) {
                    let result = element.name
                        .toLowerCase()
                        .indexOf(text.toLowerCase());

                    if (result != -1) {
                        state.labels.push(element);
                    } else if (!text) {
                        updateLabelList(store.state.label.list);
                    }
                } else {
                    state.labels = store.state.label.list;
                }
            });
        };

        onMounted(getLabels);

        return {
            state,
            getLabels,
            getLabelList,
            selectCurrentPage,
            editLabel,
            removeLabel,
            updateConfirm,
            selectedBusinessId,
            search,
            updateLabelList
        };
    }
});
</script>
